package lc.inventory;

import com.badlogic.gdx.Input.Buttons;
import com.badlogic.gdx.graphics.g2d.SpriteBatch;
import java.util.ArrayList;
import lc.item.StackItems;

/**
 * @author Death
 */
public class InventoryPocket extends InventoryParent{

    public MechCellInventory mech;
    
    public InventoryPocket(){
        mech = new MechCellInventory(9, 4);
    }
    
    
    @Override
    public void draw(SpriteBatch b){
        mech.draw(b);
    }
    
    
    @Override
    public boolean isMouseContains(int x, int y){
        return mech.isMouseContains(x, y);
    }

    @Override
    public int getX(){
        return mech.x;
    }

    @Override
    public int getY(){
        return mech.y;
    }

    @Override
    public int getWidth(){
        return mech.getWidth();
    }

    @Override
    public int getHeight(){
        return mech.getHeight();
    }

    @Override
    public void setPosition(int x, int y){
        mech.x = x;
        mech.y = y;
    }

    @Override
    public void setSize(int w, int h){
        System.out.println("lc.inventory.InventoryPocket.setSize(): " + w + " : " + h);
    }

    @Override
    public boolean addStack(StackItems si){
        return mech.addStack(si);
    }
    
    public boolean addStackNotSwob(StackItems si){
        return mech.addStack(si, false);
    }

    @Override
    public CellInventory getCellClick(int xM, int yM){
        return mech.getCellClick(xM, yM);
    }

    @Override
    public CellInventory getCellMouseContains(int xM, int yM){
        return mech.getCellClick(xM, yM);
    }
    

    @Override
    public ArrayList<CellInventory> getAllSaveCell(){
        return mech.cells;
    }

    @Override
    public void setAllSaveCell(ArrayList<CellInventory> cells){
        mech.cells = cells;
    }

    @Override
    public boolean mouseDown(int x, int y, int button){
        return super.defaultMouseDown(this.getCellClick(x, y), x, y, button);
    }
}
