package lc.inventory.invBlocks;

import com.badlogic.gdx.graphics.g2d.SpriteBatch;
import java.util.ArrayList;
import lc.inventory.CellInventory;
import lc.inventory.MechCellInventory;
import lc.item.StackItems;
import lc.item.block.Block;
import lc.utils.PropertyUtil;

/**
 * @author Death
 */
public class InventoryChest extends InventoryBlock{

    public MechCellInventory mech;
    
    public InventoryChest(Block b, PropertyUtil property, int numRow){
        super(b, property);
        super.setAutoClose(true);
        mech = new MechCellInventory(9, numRow);
    }

    @Override
    public void draw(SpriteBatch b){
        mech.draw(b);
    }

    @Override
    public int getX(){
        return mech.x;
    }

    @Override
    public int getY(){
        return mech.y;
    }

    @Override
    public int getWidth(){
        return mech.getWidth();
    }

    @Override
    public int getHeight(){
        return mech.getHeight();
    }

    @Override
    public void setPosition(int x, int y){
        mech.x = x;
        mech.y = y;
    }

    @Override
    public void setSize(int w, int h){
    }

    @Override
    public boolean isMouseContains(int x, int y){
        return mech.isMouseContains(x, y);
    }

    @Override
    public boolean addStack(StackItems si){
        return mech.addStack(si);
    }

    @Override
    public CellInventory getCellClick(int xM, int yM){
        return mech.getCellClick(xM, yM);
    }

    @Override
    public CellInventory getCellMouseContains(int xM, int yM){
        return mech.getCellClick(xM, yM);
    }
    
    @Override
    public ArrayList<CellInventory> getAllSaveCell(){
        return mech.cells;
    }

    @Override
    public void setAllSaveCell(ArrayList<CellInventory> cells){
        mech.cells = cells;
    }

    @Override
    public boolean mouseDown(int x, int y, int button){
        return super.defaultMouseDown(this.getCellClick(x, y), x, y, button);
    }

    @Override
    public ArrayList<CellInventory> getDrop(){
        return mech.cells;
    }
    
}
